3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
17 die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [-n] <repo> [<dir>]"
21 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
24 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
29 # $1 = Remote, $2 = Local
30 curl -nsfL $curl_extra_args "$1" >"$2"
34 # $1 - remote, $2 - local
36 clone_tmp="$GIT_DIR/clone-tmp" &&
37 mkdir -p "$clone_tmp" || exit 1
38 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
39 "`git-repo-config --bool http.noEPSV`" = true ]; then
40 curl_extra_args="${curl_extra_args} --disable-epsv"
42 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
43 die "Cannot get remote repository information.
44 Perhaps git-update-server-info needs to be run there?"
45 while read sha1 refname
47 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
52 yes,* | ,heads/* | ,tags/*) ;;
55 if test -n "$use_separate_remote" &&
56 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
58 tname="remotes/$origin/$branch_name"
62 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
63 done <"$clone_tmp/refs"
65 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
66 rm -f "$GIT_DIR/REMOTE_HEAD"
69 # Read git-fetch-pack -k output and store the remote branches.
71 use File::Path qw(mkpath);
72 use File::Basename qw(dirname);
73 my $git_dir = $ARGV[0];
74 my $use_separate_remote = $ARGV[1];
75 my $origin = $ARGV[2];
77 my $branch_top = ($use_separate_remote ? "remotes/$origin" : "heads");
81 my ($sha1, $name, $top) = @_;
82 $name = "$git_dir/refs/$top/$name";
83 mkpath(dirname($name));
89 open FH, "<", "$git_dir/CLONE_HEAD";
91 my ($sha1, $name) = /^([0-9a-f]{40})\s(.*)$/;
92 next if ($name =~ /\^\173/);
93 if ($name eq "HEAD") {
94 open O, ">", "$git_dir/REMOTE_HEAD";
99 if ($name =~ s/^refs\/heads\///) {
100 store($sha1, $name, $branch_top);
103 if ($name =~ s/^refs\/tags\///) {
104 store($sha1, $name, $tag_top);
122 use_separate_remote=t
126 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
127 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
129 *,--na|*,--nak|*,--nake|*,--naked|\
130 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
131 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
132 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
133 local_shared=yes; use_local=yes ;;
134 1,--template) usage ;;
136 shift; template="--template=$1" ;;
139 *,-q|*,--quiet) quiet=-q ;;
140 *,--use-separate-remote) ;;
141 *,--no-separate-remote)
142 die "clones are always made with separate-remote layout" ;;
143 1,--reference) usage ;;
145 shift; reference="$1" ;;
147 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
148 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
153 die "'$2' is not suitable for an origin name"
155 git-check-ref-format "heads/$2" ||
156 die "'$2' is not suitable for a branch name"
157 test -z "$origin_override" ||
158 die "Do not give more than one --origin options."
162 1,-u|1,--upload-pack) usage ;;
163 *,-u|*,--upload-pack)
165 upload_pack="--exec=$1" ;;
175 die 'you must specify a repository to clone.'
177 # --bare implies --no-checkout and --no-separate-remote
178 if test yes = "$bare"
180 if test yes = "$origin_override"
182 die '--bare and --origin $origin options are incompatible.'
193 # Turn the source into an absolute path if
195 if base=$(get_repo_base "$repo"); then
201 # Try using "humanish" part of source repo if user didn't specify one
202 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
203 [ -e "$dir" ] && die "destination directory '$dir' already exists."
205 D=$(cd "$dir" && pwd) &&
206 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
212 esac && export GIT_DIR && git-init-db ${template+"$template"} || usage
214 if test -n "$reference"
216 if test -d "$reference"
218 if test -d "$reference/.git/objects"
220 reference="$reference/.git"
222 reference=$(cd "$reference" && pwd)
223 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
224 (cd "$reference" && tar cf - refs) |
225 (cd "$GIT_DIR/refs" &&
226 mkdir reference-tmp &&
230 die "reference repository '$reference' is not a local directory."
234 rm -f "$GIT_DIR/CLONE_HEAD"
236 # We do local magic only when the user tells us to.
237 case "$local,$use_local" in
239 ( cd "$repo/objects" ) ||
240 die "-l flag seen but repository '$repo' is not local."
242 case "$local_shared" in
244 # See if we can hardlink and drop "l" if not.
245 sample_file=$(cd "$repo" && \
246 find objects -type f -print | sed -e 1q)
248 # objects directory should not be empty since we are cloning!
249 test -f "$repo/$sample_file" || exit
252 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
256 rm -f "$GIT_DIR/objects/sample" &&
258 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
261 mkdir -p "$GIT_DIR/objects/info"
262 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
265 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
270 rsync $quiet -av --ignore-existing \
271 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
273 # Look at objects/info/alternates for rsync -- http will
274 # support it natively and git native ones will do it on the
275 # remote end. Not having that file is not a crime.
276 rsync -q "$repo/objects/info/alternates" \
277 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
278 rm -f "$GIT_DIR/TMP_ALT"
279 if test -f "$GIT_DIR/TMP_ALT"
282 . git-parse-remote &&
283 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
286 case "$alt" in 'bad alternate: '*) die "$alt";; esac
288 '') echo >&2 "Getting alternate: $alt" ;;
290 rsync $quiet -av --ignore-existing \
291 --exclude info "$alt" "$GIT_DIR/objects" || exit
293 rm -f "$GIT_DIR/TMP_ALT"
295 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
297 https://*|http://*|ftp://*)
298 if test -z "@@NO_CURL@@"
300 clone_dumb_http "$repo" "$D"
302 die "http transport not supported, rebuild Git with curl support"
306 case "$upload_pack" in
307 '') git-fetch-pack --all -k $quiet "$repo" ;;
308 *) git-fetch-pack --all -k $quiet "$upload_pack" "$repo" ;;
309 esac >"$GIT_DIR/CLONE_HEAD" ||
310 die "fetch-pack from '$repo' failed."
315 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
317 if test -f "$GIT_DIR/CLONE_HEAD"
319 # Read git-fetch-pack -k output and store the remote branches.
320 @@PERL@@ -e "$copy_refs" "$GIT_DIR" "$use_separate_remote" "$origin" ||
326 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
328 # a non-bare repository is always in separate-remote layout
329 remote_top="refs/remotes/$origin"
330 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
333 # Uh-oh, the remote told us (http transport done against
334 # new style repository with a symref HEAD).
335 # Ideally we should skip the guesswork but for now
336 # opt for minimum change.
337 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
338 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
342 # The name under $remote_top the remote HEAD seems to point at.
346 cd "$GIT_DIR/$remote_top" &&
347 find . -type f -print | sed -e 's/^\.\///'
352 test t = $done && continue
353 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
354 if test "$head_sha1" = "$branch_tip"
363 # Write out remote.$origin config, and update our "$head_points_at".
364 case "$head_points_at" in
366 # Local default branch
367 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
369 # Tracking branch for the primary branch at the remote.
370 origin_track="$remote_top/$head_points_at" &&
371 git-update-ref HEAD "$head_sha1" &&
374 git-repo-config remote."$origin".url "$repo" &&
376 # Set up the mappings to track the remote branches.
377 git-repo-config remote."$origin".fetch \
378 "refs/heads/*:$remote_top/*" '^$' &&
379 rm -f "refs/remotes/$origin/HEAD"
380 git-symbolic-ref "refs/remotes/$origin/HEAD" \
381 "refs/remotes/$origin/$head_points_at" &&
383 git-repo-config branch."$head_points_at".remote "$origin" &&
384 git-repo-config branch."$head_points_at".merge "refs/heads/$head_points_at"
387 case "$no_checkout" in
389 test "z$quiet" = z && v=-v || v=
390 git-read-tree -m -u $v HEAD HEAD
393 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"